General Information

ReactOS Calc is a programme for evaluating mathematical, financial and statistical calculations.

ReactOS Calc has several features including:

  • Internal precision with 17 decimal numbers (standard IEEE math library).

  • Up to 512 bits of internal precision and 64 decimal digits displayed in the output display (with GNU multi-precision libraries).

  • Robust RPN (reverse polish notation) engine which allows a virtually unlimited number of arithmetic and algebraic sub-expressions.

  • Three different interfaces: standard, scientific or conversion.

  • Many common arithmetic, algebraic and statistical functions are included.

The following topics will be discussed:

HOW TO INPUT NUMBERS

DISPLAY FORMAT

ERROR MESSAGE

ARITHMETIC FUNCTIONS

LOGICAL FUNCTIONS

ALGEBRAIC FUNCTIONS

TRIGONOMETRIC FUNCTIONS

THE PI BUTTON

HYPERBOLIC FUNCTIONS

STATISTICAL FUNCTIONS

MEMORY FUNCTION

DEGREE CONVERSION

FIXED SCIENTIFIC NOTATION

PERCENT MODE


HOW TO INPUT NUMBERS

The ReactOS Calc provides some buttons for typing numbers and expressions.

However, some of them are available only into Standard, Conversion or Scientific modes, or when the calculator is in a specific state.

Digit buttons: they are used for entering digits into the display.

Hexadecimal buttons: they are used for completing an hex number.

For using these buttons, the calculator must be configured into scientific mode and the [HEX] state must be selected.

or

Decimal point: used for starting the non integer part of a decimal number.

Change sign: if it's pressed after a calculation or when entering the operands, it will change the sign of the number shown into the output display.

If the displayed number has been entered manually and it isn't a result of a calculation, you can delete the last digit by pressing this button.

This button removes an incorrect number from the output display. All pending operations are preserved.

It clears the output display and all pending operations.


DISPLAY FORMAT

You can enter digits by pressing the buttons mentioned in the HOW TO INPUT NUMBERS section.

These numbers can be entered into four different bases:

hexadecimal.

decimal.

octal.

binary system.

A number shown into the output display can be easily converted from a numeric base to another by simply changing the base on the fly.

When working with pure decimal numbers, the user can enter the numbers in two ways:

Normal mode: each number is entered its integer part and, eventually, its fractional part.

Exponential mode: the number is entered by typing a mantissa and then an exponent. This method allows you to write very big or very small numbers that you would not be able to type in a different manner.

You can use it only when the calculator is configured in scientific mode.

However, there are some limits even when you work with exponential notation.

These limits are:

-1.79769313486231570e+308 <= x <= -2.22507385850720140e-308

2.22507385850720140e-308 <= x <= 1.79769313486231570e+308

The exponential input mode is activated by the [image] button.

After the mantissa has been typed, by pressing this button you will be able to enter the exponent.

When the support for GNU multi-precision libraries is activated, these limits rise greatly to 64 displayed digits for the mantissa and 8 digits for the exponent, both with sign.

When the calculator is in [HEX], [OCT] or [BIN] state, it's possible to apply a masking for limiting the range of the numbers.

Four range are available:

It limits the integers to 64 bit numbers.

It limits the integers to 32 bit numbers.

It limits the integers to 16 bit numbers.

It limits the integers to 8 bit numbers.


ERROR MESSAGE

The output display will show the message "Error" if the current calculation overflows the limits of the calculator, or when an undefined condition is generated (example: division by zero).

The error condition is cleared using the [image] button.


ARITHMETIC FUNCTIONS

ReactOS Calc implements the standard arithmetic rules with the following operators:

Addition

Subtraction

Multiplication

Division

Remainder of a division

Those rules express the concept of priority.

Here there is a list of priorities implemented from the highest to the lowest:

  1. Special functions which change directly the current value into a new one: trigonometrics, hyperbolics, exponentials and logarithms, reciprocal, base conversions, integer and fractional part detection and change of sign.

  2. Power and root functions.

  3. Multiplications, divisions, remainders.

  4. Additions, subtractions.

  5. Logical functions.

These rules may be overcome by using parentheses.

With [image] and [image] buttons, the user can isolate a mathematical expression to be evaluated separately. The number of parentheses into a single expression is virtually unlimited. The number of currently-open parentheses is displayed in the left box underneath the base change option set.


LOGICAL FUNCTIONS

There is a set of logical functions which can be used between two operands.

They can be used as normal arithmetic operators.

The only exception is the "Not" operator which works on a single number.

The provided functions are:

It executes an "and" between the numbers.

It executes an "or" between the numbers.

It executes an "exclusive or" between the numbers.

It inverts all bits of the number shown into the output display.


ALGEBRAIC FUNCTIONS

ReactOS Calc implements the most commonly used algebraic functions.

It isolates the integer part of the number shown into the output display.

+

The integer part of the number is discarded and the fractional part stays on the output display.

Square function. It calculates the square of the number shown on the output display.

+ [image] ,

It returns the positive square root of the number shown on the output display.

If the current number is negative, then the error message will be displayed.

When working with standard and conversion layouts, the [Sqrt] button is a shortcut to this function.

Cube function. It calculates the cube of the number shown on the output display.

+

It returns the cube root of the number shown on the output display.

Power function. It calculates the power of X elevated to Y.

+

Root function. It calculates the Y-th root of X.

Reciprocal. It divides 1 by the number shown on the output display.

Factorial. It calculates the factorial of the integer part of the number shown into the output display.

The calculation is defined within these limits:

0 <= n <= 170

Natural logarithm. It calculates the natural logarithm of the current number.

ReactOS Calc assumes the Nepero's constant to be:

e=2.7182818284590452354

The calculation is defined for x > 0.

+

Natural anti-logarithm. It calculates the power of the Nepero's constant to the current number.

Decimal logarithm. It calculates the logarithm of the current number to base 10.

The calculation is defined for x > 0.

+

Decimal anti-logarithm. It calculates the power of 10 to the current number.


TRIGONOMETRIC FUNCTIONS

ReactOS Calc allows the calculation of three types of trigonometric functions with their inverse operations.

These functions can be used with three different angular units of measurement: degrees, radians or gradians.

The angular mode does not affect the non trigonometric functions.

Please note that the degree type uses decimal degrees and not angles in the degree-minute-second form.

The available functions are:

It calculates the sine of the given angle.

If the [image] modifier is activated, it finds the angle whose sine value is shown into the output display.

It calculates the cosine of the given angle.

If the [image] modifier is activated, it finds the angle whose cosine value is shown into the output display.

It calculates the tangent of the given angle.

If the [image] modifier is activated, it finds the angle whose tangent value is shown into the output display.


THE PI BUTTON

For helping the calculations with trigonometric functions, it's possible to load the value of p into the output display.

The function is called by pressing the [image] button.

If the [image] modifier is activated, then the output display will be loaded with 2*p.

In ReactOS Calc, p has the value 3.14159265358979323846


HYPERBOLIC FUNCTIONS

ReactOS Calc allows the calculation of three types of hyperbolic functions with their inverse operations.

Those functions are activated by the same buttons used for trigonometric functions; the hyperbolic context is enabled by activating the [image] modifier.

The inverse functions are activated by the [image] modifier.

+

Hyperbolic sine

+

Hyperbolic cosine

+

Hyperbolic tangent


STATISTICAL FUNCTIONS

By pressing the [image] button, the statistical window is enabled.

Statistical window allows to store groups of number and execute some common statistical operators.

Into the statistical box, there are four buttons with these functions:

[RET]

It moves the focus back to the calculator.

[LOAD]

It loads the selected number into the output display of the calculator.

[CD]

It deletes the selected number from the list.

[CAD]

It deletes all numbers currently stored into the list.

While the statistical window is shown, four additional buttons are enabled:

It calculates the arithmetic average of the numbers stored into the list.

It calculates the sum of all numbers stored into the list.

It calculates the population standard deviations of the numbers stored into the list.

It inserts the number shown into the output display into the list.

Note: when the statistical box is closed, its content is lost.


MEMORY FUNCTION

ReactOS Calc reserves for the user a memory region for storing data.

With this feature, the user can store frequently used numbers (typically, these numbers are constants) and recall them at any time, without the need to re-enter them manually.

If the memory function is currently in use, the text "M" will appear in the right box underneath the base change option set.

The memory is preserved when switching between standard, conversion and scientific modes, but its content is lost when ReactOS Calc application is closed.

Four keys are available with memory function support.

Memory Clear: clears the content of the memory.

Memory Recall: retrieves the stored data from the memory and it shows it into the output display, without affecting the content of the storage.

Memory Store: stores the displayed value into the memory. The content of the display is unaffected. After pressing this button, the previous content of the memory is lost.

If the [image] modifier is activated, then this button will swap current memory value with displayed value. Under these conditions, the displayed value is stored and the previously stored quantity is shown on the output display.

If the memory is empty, it will act as a normal store.

Memory Sum: the displayed value is algebraically added to the current memory. The output display will be unchanged after this transfer and addition.

If the [image] modifier is activated, then the displayed value will be algebraically subtracted from the memory. If the memory is empty, it will work in both condition as a simple memory store.


DEGREE CONVERSION

With [image] button you can convert decimal degrees into degree-minute-second format and vice-versa.

When working with d-m-s angles, the notation used into the output display is "DDD.MMSS" where D stands for degree, M for minute and S for second.

It will convert decimal angles to degree-minute-second angles.

+

It will convert degree-minute-second angles into decimal angles.


FIXED SCIENTIFIC NOTATION

When working with ReactOS Calc, it is possible to select a temporary scientific notation (activated by [image] button) or a fixed scientific notation.

Fixed scientific notation will be turned on by pressing [image] button.

When fixed scientific notation is active, all results will be displayed with scientific notation even for small numbers.

The calculator will be restored to normal mode by pressing [image] button again or by pressing the [image] button.


PERCENT

The [image] button is available only with standard and conversion layouts and it's used as modifier for the four basic arithmetic operators.

The input sequence for a percent calculation is:

"first" "operator" "second" "percent"

The modification applied by the percent button for each operator are:

Add "second"-% of "first" to "first".

Subtract "second"-% of "first" from "first".

Multiply "second"-% of "first" with "first".

Divide "first" by "second"-% of "first".


SHORTCUTS FROM KEYBOARD

F5 | 0
F6 | 1
F7 | 2
F8 | 3
F2 | 4
F3 | 5
F4 | 6
F12 | 7
F2 | 8
F3 | 9
F4 | A
I | B
H | C
Backspace | D
Delete | E
ESC | F
CTRL-S | +
CTRL-A | -
CTRL-T | *
CTRL-D | /
Insert | %
( | &
) | |
V | ^
X | ~
M | <
S | ;
O | =
T | CTRL-L
@ | CTRL-R
# | CTRL-M
Y | CTRL-P
N | %
L | @
! | , OR .
R | P


USING THE CLIPBOARD

You can copy the content of the output display into the clipboard.

You can also paste its content in the calculator.

The commands retrieved from the clipboard will follow the same rules mentioned in the SHORTCUTS FROM KEYBOARD section with the following exceptions:

:c

:e

:m

:p

:r

:q

\


.topic 1074
Output display

This is the place where the typed numbers and the results of the calculations are shown.

.topic 1002
Hex

It selects the hexadecimal numeric base and it converts the number shown into the output display.

Shortcut from keyboard: F5

.topic 1003
Dec

It selects the decimal numeric base and it converts the number shown into the output display.

Shortcut from keyboard: F6

.topic 1004
Oct

It selects the octal numeric base and it converts the number shown into the output display.

Shortcut from keyboard: F7

.topic 1005
Bin

It selects the binary numeric base and it converts the number shown into the output display.

Shortcut from keyboard: F8

.topic 1068
Degrees

It enables the processing of trigonometric functions into degree format.

Shortcut from keyboard: F2

.topic 1069
Radians

It enables the processing of trigonometric functions into radians format.

Shortcut from keyboard: F3

.topic 1070
Gradians

It enables the processing of trigonometric functions into gradians format.

Shortcut from keyboard: F4

.topic 1064
Qword

It limits the length of integer numbers to 64 bits.

Shortcut from keyboard: F12

.topic 1065
Dword

It limits the length of integer numbers to 32 bits.

Shortcut from keyboard: F2

.topic 1066
Word

It limits the length of integer numbers to 16 bits.

Shortcut from keyboard: F3

.topic 1067
Byte

It limits the length of integer numbers to 8 bits.

Shortcut from keyboard: F4

.topic 1006
Inv

It enables the inverse function for [sin] [cos] [tan] [pi] [x^y] [x^2] [x^3] [ln] [log] [dms] [MS] [M+] [Int] buttons.

Shortcut from keyboard: I

.topic 1007
Hyp

It enables the hyperbolic mode for [sin] [cos] [tan] buttons

Shortcut from keyboard: H

.topic 1073
Back

It deletes the last digit typed on the calculator.

It also disables the temporary scientific mode if an exponent is removed completely.

Shortcut from keyboard: Backspace

.topic 1072
CE

It deletes the last typed number from the output display.

Shortcut from keyboard: Delete

.topic 1071
CANCEL

It deletes the current calculation and all sub expressions.

Shortcut from keyboard: ESC

.topic 1014
F-E

It enables or it disables the fixed scietific notation.

Shortcut from keyboard: V

.topic 1037
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1036
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1041
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1046
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1035
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1040
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1045
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1034
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1039
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1044
This button is used for entering digits.

Shortcut from keyboard: the corresponding number on the keyboard or the numeric pad.

.topic 1038
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: A

.topic 1043
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: B

.topic 1048
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: C

.topic 1053
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: D

.topic 1058
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: E

.topic 1063
This button is used for entering hexadecimal numbers.

Shortcut from keyboard: F

.topic 1042
It changes the sign of the number.

Shortcut from keyboard: F9

.topic 1047
It adds the decimal point for a decimal number.

Shortcut from keyboard: , or .

.topic 1052
Addition

Shortcut from keyboard: +

.topic 1051
Subtraction

Shortcut from keyboard: -

.topic 1050
Multiplication

Shortcut from keyboard: *

.topic 1049
Division

Shortcut from keyboard: /

.topic 1057
It resolves the current calculation and all sub expressions.

Shortcut from keyboard: =

.topic 1054
Remainder of an integer division.

Shortcut from keyboard: %

.topic 1059
Logical "and".

Shortcut from keyboard: &

.topic 1055
Logical "or".

Shortcut from keyboard: |

.topic 1060
Logical exclusive "or".

Shortcut from keyboard: ^

.topic 1056
Logical shift to left.

Shortcut from keyboard: <

.topic 1061
Logical bit inversion.

Shortcut from keyboard: ~

.topic 1062
It isolates the Integer or fractional part of a number.

Shortcut from keyboard: ;

.topic 1029
It deletes the memory.

Shortcut from keyboard: CTRL-L

.topic 1030
It recalls a previously stored number from the memory.

Shortcut from keyboard: CTRL-R

.topic 1031
It stores a number into the memory and it eventually transfers the previous value to the output display.

Shortcut from keyboard: CTRL-M

.topic 1032
It adds or it subtracts the value into the output display to the memory.

Shortcut from keyboard: CTRL-P

.topic 1033
It loads the pi or 2*pi value into the output display.

Shortcut from keyboard: P

.topic 1019
It starts a new sub expression.

Shortcut from keyboard: (

.topic 1024
It closes and it resolves a sub expression.

Shortcut from keyboard: )

.topic 1015
It converts a decimal degree to a decimal-minute-second degree and viceversa.

Shortcut from keyboard: M

.topic 1020
It enables the temporary scientific notation.

Shortcut from keyboard: X

.topic 1025
It calculates the natural logarithm. Natural anti logarithm calculation is activated by Inv modifier.

Shortcut from keyboard: N

.topic 1026
It calculates the decimal logarithm. Decimal anti logarithm calculation is activated by Inv modifier.

Shortcut from keyboard: L

.topic 1027
It calculates the factorial of a number.

Shortcut from keyboard: !

.topic 1028
It calculates the reciprocal of a number.

Shortcut from keyboard: R

.topic 1016
It calculates the sine, hyperbolic sine, arcsine or the hyperbolic arcsine of an angle.

Shortcut from keyboard: S

.topic 1017
It calculates the cosine, hyperbolic cosine, arcsine or the hyperbolic arccosine of an angle.

Shortcut from keyboard: O

.topic 1018
It calculates the tangent, hyperbolic tangent, arcstangent or the hyperbolic arctangent of an angle.

Shortcut from keyboard: T

.topic 1021
It calculates the power of X to Y.

With the Inv modifier, it calculates the Yth root of X.

Shortcut from keyboard: Y

.topic 1022
It calculates the square of X.

With the Inv modifier, it calculates the square root of X.

Shortcut from keyboard: @

.topic 1023
It calculates the cube of X.

With the Inv modifier, it calculates the cubic root of X.

Shortcut from keyboard: $

.topic 1009
It enables the statistical window and its functions.

Shortcut from keyboard: CTRL-S

.topic 1010
It calculates the arithmetic average of the numbers stored into the statistical box.

Shortcut from keyboard: CTRL-A

.topic 1011
It calculates the sum of the numbers stored into the statistical box.

Shortcut from keyboard: CTRL-T

.topic 1012
It calculates the standard deviation of the numbers stores into the statistical box.

Shortcut from keyboard: CTRL-D

.topic 1013
It inserts a new number into the statistical box

Shortcut from keyboard: Insert

.topic 1086
It executes the calculation with percent mode.

Shortcut from keyboard: %

.topic 1085
It calculates the square root of a number.

Shortcut from keyboard: @

.topic 1087
It convert the content of the output display from a kind of unit to another one.